<?php
require_once '../lib/config.php';

function action(&$c) {
	if ($_POST) {
		$mode = $_POST['mode'];
	} else if ($_GET['mode']) {
		$mode = $_GET['mode'];
	}
	if ($mode) {
		$action = new CAction($c);
		if (method_exists($action, $mode)) {
			$action->$mode();
		}
	}
	
	$redirect = '';
	$category_id = $_GET['category_id'];
	$category2_id = $_GET['category2_id'];
	$page_id = $_GET['page_id'];
	if (!$category_id) {
		if ($category = $c->category->find(null, 'seq')) {
			$category_id = $category['id'];
			$redirect = "category_id=$category_id";
		}
	}
	if (!$category2_id) {
		if ($category2 = $c->category2->find(array('category_id' => $category_id), 'seq')) {
			$category2_id = $category2['id'];
			$redirect = "category_id=$category_id&category2_id=$category2_id";
		}
	}
	if (!$page_id) {
		if ($page = $c->page->find(array('category2_id' => $category2_id), 'seq')) {
			$page_id = $page['id'];
			$redirect = "category_id=$category_id&category2_id=$category2_id&page_id=$page_id";
		}
	}
	if ($redirect) {
		$c->redirect('category.php?' . $redirect);
	}
	
	$c->set('config', $c->config->find(array('id' => 1)));
	
	$c->set('categories', $c->category->findAll(null, 'seq'));
	if ($category_id = $_GET['category_id']) {
		$c->set('category', $c->category->read($category_id));
		$c->set('categories2', $c->category2->findAll(array('category_id' => $category_id), 'seq'));
	}
	if ($category2_id = $_GET['category2_id']) {
		$c->set('pages', $c->page->findAll(array('category2_id' => $category2_id), 'seq'));
		$c->set('category2', $c->category2->find(array('id' => $category2_id)));
	}
	if ($page_id = $_GET['page_id']) {
		$c->set('page', $c->page->find(array('id' => $page_id)));
	}
	$c->set('category_id', $category_id);
	$c->set('category2_id', $category2_id);
	$c->set('page_id', $page_id);
}

class CAction {
	
	var $controller = null;
	var $c = null;
	
	function CAction(&$c) {
		$this->controller = $c;
		$this->c = $c;
	}
	
	function redirect($url) {
		$this->c->site->generate();
		$this->c->redirect($url);
	}
	
	function category_add() {
		$category = $_POST['category'];
		if ($category['name']) {
			$max = $this->c->category->find(null, 'seq DESC');
			$category['seq'] = $max['seq'] + 1;
			$this->c->category->insert($category);
			$id = $this->c->category->getInsertId();
			$category = $this->c->category->read($id);
			$params = array(
				'category' => $category,
			);
			$plugins = $this->c->plugin->findAllWithClass(array('used' => 1));
			foreach ($plugins as $plugin) {
				if (method_exists($plugin['class'], 'addCategory')) {
					$plugin['class']->addCategory($params);
				}
			}
			$this->redirect($_SERVER['REQUEST_URI']);
		} else {
			$this->c->set('error', 'タイトルを入力して下さい。');
		}
	}

	function category2_add() {
		$category2 = $_POST['category2'];
		if ($category2['name']) {
			$max = $this->c->category2->find(null, 'seq DESC');
			$category2['seq'] = $max['seq'] + 1;
			$category2['category_id'] = $_GET['category_id'];
			$this->c->category2->insert($category2);
			$id = $this->c->category2->getInsertId();
			$newpage = array(
				'url' => $id . '/',
				'name' => $category2['name'],
				'created' => date('Y-m-d H:i:s'),
			);
			$this->c->newpage->insert($newpage);
			$category2 = $this->c->category2->read($id);
			$category = $this->c->category->read($category2['category_id']);
			$params = array(
				'category' => $category,
				'category2' => $category2,
			);
			$plugins = $this->c->plugin->findAllWithClass(array('used' => 1));
			foreach ($plugins as $plugin) {
				if (method_exists($plugin['class'], 'addCategory2')) {
					$plugin['class']->addCategory2($params);
				}
			}
			$this->redirect($_SERVER['REQUEST_URI']);
		} else {
			$this->c->set('error', 'タイトルを入力して下さい。');
		}
	}
	
	function page_add() {
		$page = $_POST['page'];
		if ($page['name']) {
			$max = $this->c->page->find(null, 'seq DESC');
			$page['seq'] = $max['seq'] + 1;
			$page['category2_id'] = $_GET['category2_id'];
			$page['created'] = date('Y-m-d H:i:s');
			$this->c->page->insert($page);
			$newpage = array(
				'url' => $page['category2_id'] . '/' . $this->c->page->getInsertId(),
				'name' => $page['name'],
				'created' => $page['created'],
			);
			$this->c->newpage->insert($newpage);
			$id = $this->c->page->getInsertId();
			$page = $this->c->page->read($id);
			$category2 = $this->c->category2->read($page['category2_id']);
			$category = $this->c->category->read($category2['category_id']);
			$params = array(
				'category' => $category,
				'category2' => $category2,
				'page' => $page,
			);
			$plugins = $this->c->plugin->findAllWithClass(array('used' => 1));
			foreach ($plugins as $plugin) {
				if (method_exists($plugin['class'], 'addPage')) {
					$plugin['class']->addPage($params);
				}
			}
			$this->redirect($_SERVER['REQUEST_URI']);
		} else {
			$this->c->set('error', 'タイトルを入力して下さい。');
		}
	}
	
	function edit() {
		if ($_GET['category_id']) {
			$category = $_POST['category'];
			$category['id'] = $_GET['category_id'];
			$this->c->category->update($category);
		}
		if ($_GET['category2_id']) {
			$category2 = $_POST['category2'];
			$category2['id'] = $_GET['category2_id'];
			$newpage = $this->c->newpage->find(array('url' => $category2['id'] . '/'));
			$this->c->newpage->update(array('id' => $newpage['id'], 'name' => $category2['name']));
			$this->c->category2->update($category2);
		}
		if ($_GET['page_id']) {
			$page = $_POST['page'];
			$page['id'] = $_GET['page_id'];
			$newpage = $this->c->newpage->find(array('url' => $category2['id'] . '/' . $page['id']));
			$this->c->newpage->update(array('id' => $newpage['id'], 'name' => $page['name']));
			$this->c->page->update($page);
		}
		$this->redirect($_SERVER['REQUEST_URI']);
	}
	
	function category_del() {
		$category = $this->c->category->find(array('id' => $_GET['category_id']));
		$this->c->category->del($category['id']);
		$categories = $this->c->category2->findAll(array('category_id' => $category['id']));
		$this->c->category2->deleteAll(array('category_id' => $category['id']));
		foreach ($categories as $category2) {
			$this->c->page->deleteAll(array('category2_id' => $category2['id']));
			$this->c->site->deleteDir(SITE_PATH . $category2['id']);
		}
		$this->redirect('category.php');
	}
	
	function category2_del() {
		$category2 = $this->c->category2->find(array('id' => $_GET['category2_id']));
		$this->c->category2->del($category2['id']);
		$this->c->page->deleteAll(array('category2_id' => $category2['id']));
		$this->c->newpage->deleteAll(array('url' => $category2['id'] . '/'));
		$this->c->site->deleteDir(SITE_PATH . $category2['id']);
		$this->redirect('category.php?category_id=' . $category2['category_id']);
	}
	
	function page_del() {
		$page = $this->c->page->find(array('id' => $_GET['page_id']));
		$category2 = $this->c->category2->read($page['category2_id']);
		$this->c->page->del($page['id']);
		$this->c->newpage->deleteAll(array('url' => $page['category2_id'] . '/' . $page['id']));
		$this->c->site->deleteFile(SITE_PATH . $page['category2_id'] . '/' . $page['id']);
		$this->redirect('category.php?category_id=' . $category2['category_id'] . '&category2_id=' . $page['category2_id']);
	}
	
	function config() {
		$config = $_POST['config'];
		$config['id'] = 1;
		$this->c->config->update($config);
		$this->redirect($_SERVER['REQUEST_URI']);
	}
	
	function category_up() {
		$categories = $this->c->category->findAll(null, 'seq');
		foreach ($categories as $i => $category) {
			if ($category['id'] == $_GET['category_id']) {
				$save = $categories[$i - 1];
				$categories[$i - 1] = $category;
				$categories[$i] = $save;
				break;
			}
		}
		foreach ($categories as $i => $category) {
			$this->c->category->update(array('id' => $category['id'], 'seq' => $i));
		}
		$this->redirect(str_replace('&mode=category_up', '', $_SERVER['REQUEST_URI']));
	}
	
	function category_down() {
		$categories = $this->c->category->findAll(null, 'seq');
		foreach ($categories as $i => $category) {
			if ($category['id'] == $_GET['category_id']) {
				$save = $categories[$i + 1];
				$categories[$i + 1] = $category;
				$categories[$i] = $save;
				break;
			}
		}
		foreach ($categories as $i => $category) {
			$this->c->category->update(array('id' => $category['id'], 'seq' => $i));
		}
		$this->redirect(str_replace('&mode=category_down', '', $_SERVER['REQUEST_URI']));
	}
	
	function category2_up() {
		$categories = $this->c->category2->findAll(null, 'seq');
		foreach ($categories as $i => $category) {
			if ($category['id'] == $_GET['category2_id']) {
				$save = $categories[$i - 1];
				$categories[$i - 1] = $category;
				$categories[$i] = $save;
				break;
			}
		}
		foreach ($categories as $i => $category) {
			$this->c->category2->update(array('id' => $category['id'], 'seq' => $i));
		}
		$this->redirect(str_replace('&mode=category2_up', '', $_SERVER['REQUEST_URI']));
	}
	
	function category2_down() {
		$categories = $this->c->category2->findAll(null, 'seq');
		foreach ($categories as $i => $category) {
			if ($category['id'] == $_GET['category2_id']) {
				$save = $categories[$i + 1];
				$categories[$i + 1] = $category;
				$categories[$i] = $save;
				break;
			}
		}
		foreach ($categories as $i => $category) {
			$this->c->category2->update(array('id' => $category['id'], 'seq' => $i));
		}
		$this->redirect(str_replace('&mode=category2_down', '', $_SERVER['REQUEST_URI']));
	}
	
	function page_up() {
		$pages = $this->c->page->findAll(null, 'seq');
		foreach ($pages as $i => $page) {
			if ($page['id'] == $_GET['page_id']) {
				$save = $pages[$i - 1];
				$pages[$i - 1] = $page;
				$pages[$i] = $save;
				break;
			}
		}
		foreach ($pages as $i => $page) {
			$this->c->page->update(array('id' => $page['id'], 'seq' => $i));
		}
		$this->redirect(str_replace('&mode=page_up', '', $_SERVER['REQUEST_URI']));
	}
	
	function page_down() {
		$pages = $this->c->page->findAll(null, 'seq');
		foreach ($pages as $i => $page) {
			if ($page['id'] == $_GET['page_id']) {
				$save = $pages[$i + 1];
				$pages[$i + 1] = $page;
				$pages[$i] = $save;
				break;
			}
		}
		foreach ($pages as $i => $page) {
			$this->c->page->update(array('id' => $page['id'], 'seq' => $i));
		}
		$this->redirect(str_replace('&mode=page_down', '', $_SERVER['REQUEST_URI']));
	}
}

