<?php
class CSite extends CObject {
	
	var $config = null;
	var $style = null;
	var $plugins = null;
	
	function generate() {
		require_once dirname(dirname(__FILE__)) . '/pear/Common/class.php';
		$comp = new CommonComponent();
		$comp->setController($this->controller);
		$comp->setUrls();
		$this->controller->plugin->needPandemic = true;
		$this->deleteCategory();
		$this->deleteSearch();
		$this->deleteLink();
		$this->deleteIndex();
		$this->deleteCopyright();
		if (!$this->generateStart()) return false;
		$this->generateCopyright();
		$this->generateCategories();
		$this->generateLinks();
		$this->generateSearchPagesAll();
		$this->generateIndex();
		$this->generateRss();
		$this->generateSitemap();
		$this->controller->plugin->needPandemic = false;
		$comp->delUrls();
		return true;
	}
	
	
	function generateStart($preview = null) {
		if (!$this->config) {
			$this->config = $this->controller->config->read(1);
			if (!$this->config['style']) $this->config['style'] = 'classic';
			if (!$this->config['ext']) $this->config['ext'] = 'html';
			if ($preview) $this->config['style'] = $preview;
			$this->style = $this->controller->style->getClass($this->config['style']);
			if (!$this->style) {
				return false;
			}
			$this->style->setController($this->controller);
		}
		return true;
	}
	
	
	function getPlugins() {
		if (!$this->plugins) {
			$this->plugins = $this->controller->plugin->findAllWithClass(array('used' => 1));
		}
		return $this->plugins;
	}
	
	
	function generateIndex($preview = null) {
		$comp = null;
		if (!$this->controller->plugin->needPandemic) {
			require_once dirname(dirname(__FILE__)) . '/pear/Common/class.php';
			$comp = new CommonComponent();
			$comp->setController($this->controller);
			$comp->setUrls();
			$this->controller->plugin->needPandemic = true;
		}
		
		$this->generateStart($preview);
		
		if ($comp) {
			$config = $this->controller->config->read(1);
			$this->config['ad2'] = $config['ad2'];
		}
		
		//newpage
		$newpages = array();
		$results = $this->controller->newpage->findAll(null, 'created DESC');
		foreach ($results as $i => $newpage) {
			$filename = SITE_PATH . $newpage['url'];
			if ($filename[strlen($filename) - 1] == '/') $filename .= 'index.' . $this->config['ext'];
			else $filename .=  '.' . $this->config['ext'];
			if (file_exists($filename)) {
				$newpage['newpage_year'] = substr($newpage['created'], 0, 4);
				$newpage['newpage_month'] = (int)substr($newpage['created'], 5, 2);
				$newpage['newpage_day'] = (int)substr($newpage['created'], 8, 2);
				$newpage['newpage_hour'] = (int)substr($newpage['created'], 11, 2);
				$newpage['newpage_minute'] = (int)substr($newpage['created'], 14, 2);
				$newpage['newpage_second'] = (int)substr($newpage['created'], 17, 2);
 				$url = null;
 				if ($pageId = $this->controller->newpage->getPageId($newpage)) {
 					$page = $this->controller->page->read($pageId);
 					if ($page['url']) $url = $page['url'];
 				} else if ($category2Id = $this->controller->newpage->getCategory2Id($newpage)) {
 					$category2 = $this->controller->category2->read($category2Id);
 					if ($category2['url']) $url = $category2['url'];
 				}
 				if ($url) {
 					$newpage['newpage_url'] = $url;
 				} else {
 					$newpage['newpage_url'] = $this->config['url'] . $newpage['url'];
 					if ($newpage['url'][strlen($newpage['url']) - 1] != '/') $newpage['newpage_url'] .= '.' . $this->config['ext'];
 				}
				$newpage['newpage_name'] = h($newpage['name']);
				$newpages[$i] = $newpage;
			}
		}
		
		//category
		$categories = $this->controller->category->findAll(null, 'seq');
		foreach ($categories as $i => $category) {
			$category['category_name'] = h($category['name']);
			$category['sub_categories'] = $this->controller->category2->findAll(array('category_id' => $category['id']), 'seq');
			foreach ($category['sub_categories'] as $j => $sub_category) {
				$sub_category['sub_category_name'] = h($sub_category['name']);
				if ($sub_category['url']) {
					$sub_category['sub_category_url'] = h($sub_category['url']);
				} else {
					$sub_category['sub_category_url'] = h($this->config['url']) . $sub_category['id'] . '/';
				}
				$category['sub_categories'][$j] = $sub_category;
			}
			$categories[$i] = $category;
		}
		
		//link
		$linksOriginal = $this->controller->link->findAll();
		$results = array_slice($linksOriginal, 0, 5);
		$links = array();
		foreach ($results as $row) {
			if ($row['url']) {
				$link['link_name'] = h($row['name']);
				$link['link_name'] = $row['image'] ? ('<img src="' . h($row['image']) . '" border="0" />') : h($row['name']);
				$link['link_url'] = h($row['url']);
				$links[] = $link;
			}
		}
		
		$params = array(
			'config' => $this->config,
			'newpages' => $newpages,
			'categories' => $categories,
			'links' => $links,
			'preview' => $preview,
		);
		$result = $this->style->generateIndex($params);
		if ($comp) {
			$this->controller->plugin->needPandemic = false;
			$comp->delUrls();
		}
		return $result;
	}
	
	
	function generateCopyright() {
		$this->generateStart();
		$params = array(
			'config' => $this->config,
		);
		return $this->style->generateCopyright($params);
	}
	
	
	function generateCategories() {
		$this->generateStart();
		$plugins = $this->controller->plugin->findAllWithClass(array('used' => 1));
		$categories = $this->controller->category->findAll(null, 'seq');
		foreach ($categories as $category) {
			$categories2 = $this->controller->category2->findAll(array('category_id' => $category['id']), 'seq');
			foreach ($categories2 as $i => $category2) {
				if ($category2['url']) {
					$category2['sub_category_url'] = h($category2['url']);
				} else {
					$category2['sub_category_url'] = $this->config['url'] . $category2['id'] . '/';
				}
				$category2['sub_category_name'] = h($category2['name']);
				$categories2[$i] = $category2;
			}
			foreach ($categories2 as $category2) {
				$pages = $this->controller->page->findAll(array('category2_id' => $category2['id']), 'seq');
				$params = array(
					'config' => $this->config,
					'category' => $category,
					'category2' => $category2,
					'categories2' => $categories2,
					'pages' => $pages,
				);
				$this->style->generateCategories($params);
			}
		}
	}
	
	
	function generatePages($category, $category2, $pages) {
		$this->generateStart();
		$params = array(
			'config' => $this->config,
			'category' => $category,
			'category2' => $category2,
			'pages' => $pages,
		);
		$this->style->generatePages($params);
	}
	
	
	function generateSearchPagesAll() {
		$list = $this->controller->keyword->findList();
		foreach ($list as $i => $keyword) {
			$this->generateSearchPages($i + 1, $keyword);
		}
	}
	
	
	function generateSearchPages($id = null, $keyword = null) {
		$this->generateStart();
		$plugins = $this->controller->plugin->findAllWithClass(array('used' => 1));
		$pages = array();
		$params = array(
			'controller' => $this->controller,
		);
		foreach ($plugins as $plugin) {
			if (method_exists($plugin['class'], 'generateSearchPages')) {
				if ($results = $plugin['class']->generateSearchPages($keyword, $params)) {
					$pages = array_merge($pages, $results);
				}
			}
		}
		if (!$pages) {
			$pages = $this->controller->page->findAllByKeyword($keyword);
			foreach ($pages as $i => $page) {
				$page['page_link'] = $this->config['url'] . $page['category2_id'] . '/' . $page['id'] . '.' . $this->config['ext'];
				$page['page_name'] = h($page['name']);
				$pages[$i] = $page;
			}
			$categoryPages = $this->controller->category2->findAllByKeyword($keyword);
			foreach ($categoryPages as $page) {
				$page['page_link'] = $this->config['url'] . $page['id'] . '/';
				$page['page_name'] = h($page['name']);
				$pages[] = $page;
			}
		}
		if (!$pages) return false;

		$params = array(
			'config' => $this->config,
			'pages' => $pages,
			'id' => $id,
			'keyword' => $keyword,
		);
		$this->style->generateSearchPages($params);
		return true;
	}
	
	
	function generateLinks() {
		$this->generateStart();
		$params = array(
			'config' => $this->config,
		);
		return $this->style->generateLinks($params);
	}
	
	
	function generateMessage($msg) {
		$this->generateStart();
		$params = array(
			'config' => $this->config,
			'msg' => $msg,
		);
		return $this->style->generateMessage($params);
	}
	
	
	function generateRss() {
		$this->generateStart();
		$params = array(
			'config' => $this->config,
		);
		$this->style->generateRss($params);
	}
	
	
	function generateSitemap() {
		$this->controller->config->update(array('id' => 1, 'page_count' => $this->style->getPageCount()));
		$params = array(
			'config' => $this->config,
		);
		$this->style->generateSitemap($params);
	}
	
	
	function getCopyright() {
		return '<a href="' . $this->convertInput('config_url', $this->config['url']) . 'copyright.' . $this->config['ext'] . '">' . $this->convertInput('config_copyright', h($this->config['copyright'])) . '</a>';
	}
	
	
	function output($path, $data) {
		if ($fp = fopen($path, 'w')) {
			flock($fp, LOCK_EX);
			fputs($fp, $data);
			fclose($fp);
			chmod($path, 0644);
			return true;
		}
		return false;
	}
	
	
	function deleteCategory() {
		$categories = $this->controller->category2->findAll();
		foreach ($categories as $category2) {
			$this->deleteDir(SITE_PATH . $category2['id']);
		}
		if (method_exists($this->style, 'deleteCategory')) {
			$params = array(
				'categories' => $categories,
			);
			$this->style->deleteCategory($params);
		}
	}
	
	
	function deleteSearch() {
		$this->deleteInDir(SITE_PATH . 'search');
		if (method_exists($this->style, 'deleteSearch')) {
			$params = array();
			$this->style->deleteSearch($params);
		}
	}
	
	
	function deleteLink() {
		$this->deleteInDir(SITE_PATH . 'link');
		if (method_exists($this->style, 'deleteLink')) {
			$params = array();
			$this->style->deleteLink($params);
		}
	}
	
	
	function deleteIndex() {
		$this->deleteFile(SITE_PATH . 'index');
		if (method_exists($this->style, 'deleteIndex')) {
			$params = array();
			$this->style->deleteIndex($params);
		}
	}
	
	
	function deleteCopyright() {
		$this->deleteFile(SITE_PATH . 'copyright');
		if (method_exists($this->style, 'deleteCopyright')) {
			$params = array();
			$this->style->deleteCopyright($params);
		}
	}
	
	
	function deleteDir($path) {
		if (file_exists($path)) {
			if (is_dir($path)) {
				if ($dir = @opendir($path)) {
					while (($file = readdir($dir)) !== false) {
						if ($file != '.' && $file != '..') {
							$this->deleteDir("$path/$file");
						}
					}
				}
				@rmdir("$path/$file");
			} else {
				@unlink($path);
			}
		}
	}
	
	
	function deleteInDir($path) {
		if (file_exists($path)) {
			if (is_dir($path)) {
				if ($dir = @opendir($path)) {
					while (($file = readdir($dir)) !== false) {
						if ($file != '.' && $file != '..') {
							@unlink("$path/$file");
						}
					}
				}
			}
		}
	}
	
	
	function deleteFile($path) {
		foreach ($GLOBALS['EXTENTIONS'] as $ext) {
			@unlink("$path.$ext");
		}
	}
	
	
	function replaceCommon($out, $changes = array()) {
		$replace = array(
			'url' => $this->convertInput('config_url', h($this->config['url'])),
			'title' => $this->convertInput('config_title', h($this->config['title'])),
			'description' => $this->convertInput('config_description', h($this->config['description'])),
			'keyword' => $this->convertInput('config_keyword', h($this->config['keyword'])),
			'ad_header' => $this->convertInput('config_ad1', $this->config['ad1']),
			'main_description' => $this->convertInput('config_main_description', nl2br($this->config['main_description'])),
			'marquee' => $this->convertInput('config_marquee', h($this->config['marquee'])),
			'link_title' => $this->convertInput('config_link_title', h($this->config['link_title'])),
			'ad_footer' => $this->convertInput('config_ad2', $this->config['ad2']),
			'copyright' => $this->getCopyright(),
		);
		$replace = array_merge($replace, $changes);
		$out = $this->replaceParams($out, $replace);
		return $out;
	}
	
	
	function replaceLoop($out, $name, $data) {
		$pos = 0;
		$startTag = "<!--$name-->";
		$endTag = "<!--/$name-->";
		$startLength = strlen($startTag);
		$endLength = strlen($endTag);
		while(($startpos = strpos($out, $startTag, $pos)) !== false) {
			$startpos += $startLength;
			if (($endpos = strpos($out, $endTag, $startpos)) === false) break;
			$inner = substr($out, $startpos, $endpos - $startpos);
			$parts = '';
			$count = count($data);
			foreach ($data as $i => $row) {
				$part = $this->replaceParams($inner, $row);
				$part = preg_replace('/<!--if first-->([^<]*)<!--else-->([^<]*)<!--\/if-->/', !$i ? '$1' : '$2', $part);
				$part = preg_replace('/<!--if last-->([^<]*)<!--else-->([^<]*)<!--\/if-->/', $i == $count - 1 ? '$1' : '$2', $part);
				$parts .= $part;
			}
			$out = substr_replace($out, $parts, $startpos, $endpos - $startpos);
			$pos = $startpos + 1;
		}
		return $out;
	}
	
	
	function replaceParams($out, $replaces) {
		foreach ($replaces as $key => $value) {
			if (is_array($value)) {
				$out = $this->replaceLoop($out, $key, $value);
			} else {
				$out = str_replace('$' . $key, $value, $out);
			}
		}
		return $out;
	}
	
	
	function input($id, $name, $attributes = array()) {
		$out = $this->beforeInput($id, $name, $attributes);
		
		$plugins = $this->controller->plugin->findAllWithClass(array('used' => 1));
		$inputOut = '';
		foreach ($plugins as $plugin) {
			if (method_exists($plugin['class'], 'getInput')) {
				$inputOut .= $plugin['class']->getInput($id, $name, $attributes);
			}
		}
		if ($inputOut) {
			$out .= $inputOut;
		} else {
			if (!array_key_exists('id', $attributes)) {
				$attributes['id'] = $id;
			}
			$out .= '<input type="text" name="' . $name . '"';
			foreach ($attributes as $key => $value) {
				$out .= ' ' . $key . '="' . ($key == 'value' ? h($value) : $value) . '"';
			}
			$out .= ' />';
		}
		
		$out .= $this->afterInput($id, $name, $attributes);
		echo $out;
	}
	
	
	function textarea($id, $name, $attributes = array()) {
		$out = $this->beforeInput($id, $name, $attributes);
		
		$plugins = $this->controller->plugin->findAllWithClass(array('used' => 1));
		$inputOut = '';
		foreach ($plugins as $plugin) {
			if (method_exists($plugin['class'], 'getInput')) {
				$inputOut .= $plugin['class']->getInput($id, $name, $attributes);
			}
		}
		if ($inputOut) {
			$out .= $inputOut;
		} else {
			if (array_key_exists('value', $attributes)) {
				$inputValue = $attributes['value'];
				unset($attributes['value']);
			}
			if (!array_key_exists('id', $attributes)) {
				$attributes['id'] = $id;
			}
			$out .= '<textarea name="' . $name . '"';
			foreach ($attributes as $key => $value) {
				$out .= ' ' . $key . '="' . h($value) . '"';
			}
			$out .= '>' . h($inputValue) . '</textarea>';
		}
		
		$out .= $this->afterInput($id, $name, $attributes);
		echo $out;
	}
	
	
	function beforeInput($id, $name, $attributes) {
		$out = '';
		$plugins = $this->controller->plugin->findAllWithClass(array('used' => 1));
		foreach ($plugins as $plugin) {
			if (method_exists($plugin['class'], 'getBeforeInput')) {
				$out .= $plugin['class']->getBeforeInput($id, $name, $attributes);
			}
		}
		return $out;
	}
	
	
	function afterInput($id, $name, $attributes) {
		$out = '';
		$plugins = $this->controller->plugin->findAllWithClass(array('used' => 1));
		foreach ($plugins as $plugin) {
			if (method_exists($plugin['class'], 'getAfterInput')) {
				$out .= $plugin['class']->getAfterInput($id, $name, $attributes);
			}
		}
		return $out;
	}
	
	
	function convertInput($id, $value) {
		$plugins = $this->getPlugins();
		foreach ($plugins as $plugin) {
			if (method_exists($plugin['class'], 'convertInput')) {
				$value = $plugin['class']->convertInput($id, $value);
			}
		}
		return $value;
	}
}
