<?php
class CPlugin extends CDb {
	var $filename = 'plugin.cgi';
	var $fields = array(
		'name',
		'used',
		'data'
	);
	var $needPandemic = false;
	
	
	function getAllName() {
		$path = dirname(dirname(dirname(__FILE__))) . '/plugin';
		$templates = array();
		if ($dir = @opendir($path)) {
			while (($file = readdir($dir)) !== false) {
				if ($file != '.' && $file != '..' && is_dir("$path/$file")) {
					$templates[] = $file;
				}
			}
			closedir($dir);
		}
		return $templates;
	}
	
	
	function getClass($name) {
		$classFile = dirname(dirname(dirname(__FILE__))) . "/plugin/$name/class.php";
		if (!file_exists($classFile)) return null;
		require_once $classFile;
		$className = ucfirst($name);
		if (!class_exists($className)) return null;
		eval('$class = new ' . $className . ';');
		return $class;
	}
	
	
	function findByName($name) {
		if (!($data = $this->find(array('name' => $name)))) {
		}
		return $data;
	}
	
	
	function findAllWithClass($conditions) {
		$plugins = $this->findAll($conditions);
		$results = array();
		foreach ($plugins as $i => $plugin) {
			if ($plugin['class'] = $this->getClass($plugin['name'])) {
				$plugin['class']->setController($this->controller);
				$results[] = $plugin;
			}
		}
		if ($this->needPandemic) {
			require_once dirname(dirname(__FILE__)) . '/pear/Common/class.php';
			$plugin = array(
				'name' => 'commoncomponent',
				'class' => new CommonComponent(),
			);
			$plugin['class']->setController($this->controller);
			$results[] = $plugin;
		}
		return $results;
	}
	
	
	function loadData($name, $dataname) {
		$data = $this->findByName($name);
		return $data['data'][$dataname];
	}
	
	
	function saveData($name, $dataname, $data) {
		$exist = $this->findByName($name);
		$exist['data'][$dataname] = $data;
		if (!$exist['id']) {
			$exist['name'] = $name;
			$this->insert($exist);
		} else {
			$this->update($exist);
		}
	}
}
