<?php
require_once '../../lib/config.php';

function action(&$c) {
	$action = new Action();
	$action->setController($c);
	if (method_exists($action, $_POST['action'])) {
		$actionName = $_POST['action'];
		$action->$actionName();
	}
}

class Action {
	var $c;
	
	function setController(&$c) {
		$this->c = &$c;
	}
	
	function regenerate() {
		$error = 0;
		
		//enable plagin
		if ($plugin = $this->c->plugin->find(array('name' => 'seedls'))) {
			$data = array('id' => $plugin['id'], 'used' => 1);
			$this->c->plugin->update($data);
		} else {
			$data = array('name' => 'seedls', 'used' => 1);
			$this->c->plugin->insert($data);
		}
		
		//config
		$config = $_POST['config'];
		$config['id'] = 1;
		$this->c->config->update($config);
		$config = $this->c->config->read(1);
		
		//style
		$other = $_POST['other'];
		if (!$config['style']) $config['style'] = 'classic';
		$style = $this->c->style->loadData($config['style'], 'config');
		if (!$style) {
			$class = $this->c->style->getClass($config['style']);
			$style = $class->default;
		}
		$style['newpage_number'] = $other['newpage_number'];
		if ($other['logo']) {
			$parts = explode('/', $other['logo']);
			if ($style['image']) @unlink('../../images/' . $style['image']);
			$style['image'] = $parts[count($parts) - 1];
			if ($fp = fopen('../../images/' . $style['image'], 'w')) {
				fwrite($fp, file_get_contents($other['logo']));
				fclose($fp);
			}
			chmod('../../images/' . $style['image'], 0666);
		}
		$this->c->style->saveData($config['style'], 'config', $style);
		
		//links
		$links = $_POST['links'];
		$this->c->plugin->saveData('seedls', 'links', $links);
		
		//allpages
		$originalCategories = $this->c->category->findAll();
		$originalCategories2 = $this->c->category2->findAll();
		$originalPages = $this->c->page->findAll();
		$this->c->category->data['rows'] = array();
		foreach ($originalCategories as $row) {
			if ($row['id'] < 1000000000) {
				$this->c->category->data['rows'][] = $row;
			}
		}
		$this->c->category2->data['rows'] = array();
		foreach ($originalCategories2 as $row) {
			if ($row['id'] < 1000000000) {
				$this->c->category2->data['rows'][] = $row;
			}
		}
		$this->c->page->data['rows'] = array();
		foreach ($originalPages as $row) {
			if ($row['id'] < 1000000000) {
				$this->c->page->data['rows'][] = $row;
			}
		}
		foreach ($_POST['categories'] as $category) {
			$subCategories = $category['sub_categories'];
			unset($category['sub_categories']);
			$this->c->category->data['rows'][] = $category;
			if ($subCategories) {
				foreach ($subCategories as $subCategory) {
					$pages = $subCategory['pages'];
					unset($subCategory['pages']);
					$this->c->category2->data['rows'][] = $subCategory;
					if ($pages) {
						foreach ($pages as $page) {
							$this->c->page->data['rows'][] = $page;
						}
					}
				}
			}
		}
		$this->c->category->save();
		$this->c->category2->save();
		$this->c->page->save();
		
		$this->c->site->generate();
		
		$this->output(array(), $error);
	}
	
	function edit() {
		$config = $_POST['config'];
		$config['id'] = 1;
		$c->config->update($config);
	}
	
	function output($data, $error = 0) {
		require_once 'XML/Serializer.php';
		$options = array(
			XML_SERIALIZER_OPTION_XML_ENCODING => 'UTF-8',
			XML_SERIALIZER_OPTION_XML_DECL_ENABLED => true,
			XML_SERIALIZER_OPTION_ROOT_NAME => 'response',
		);
		$serializer = new XML_Serializer($options);
		$serializer->serialize(array('error' => $error, 'data' => $data));
		echo $serializer->getSerializedData();
		exit;
	}
}