<?php
class Classic extends Style {
	var $name = 'classic';
	var $description = '基本テンプレートです。カラー変更などが可能です。';
	var $default = array(
		'bgcolor' => '#FFFFFF',
		'fontsize' => '3',
		'text' => '#000000',
		'link' => '',
		'vlink' => '',
		'alink' => '',
		'marquee' => '#000000',
		'marquee_color' => 'red',
		'category_bgcolor' => '#0033CC',
		'category_color' => 'white',
		'link_color' => '',
		'link_bgcolor' => '#FF0000',
		'new_color' => '#FFFFFF',
		'new_bgcolor' => '#0033CC',
		'pages_color' => '#FFFFFF',
		'pages_bgcolor' => '#FF0000',
		'newpage_number' => '5',
	);
	var $urls = array();
	var $style = null;
	
	
	function generateStart($params) {
		static $started = false;
		if (!$started) {
			$this->urls = array();
			$this->style = $this->controller->style->loadData('classic', 'config');
			$this->config = $params['config'];
			$started = true;
		}
	}
	
	
	function generateIndex($params) {
		$this->generateStart($params);
		$out = file_get_contents(dirname(__FILE__) . '/web_templates/index.html');
		$out = $this->replaceLogo($out);
		$plugins = $this->controller->plugin->findAllWithClass(array('used' => 1));
		
		$pluginHtml = array('', '', '', '', '', '');
		$pluginHeader = '';
		$pluginParams = array('controller' => $this->controller);
		foreach ($plugins as $plugin) {
			for ($i = 0; $i < 6; $i++) {
				if (method_exists($plugin['class'], 'generateIndex')) {
					$pluginHtml[$i] .= $plugin['class']->generateIndex($i + 1, $pluginParams);
				}
				if (method_exists($plugin['class'], 'generateIndexHeader')) {
					$pluginHeader .= $plugin['class']->generateIndexHeadder($pluginParams);
				}
			}
		}
		
		$params['newpages'] = array_slice($params['newpages'], 0, $this->style['newpage_number']);
		if ($this->style['hide_newpage_date']) {
			$out = $this->controller->site->replaceLoop($out, 'newpage_date', array());
		}
		if ($params['newpages']) {
			$out = $this->controller->site->replaceLoop($out, 'newpages', $params['newpages']);
		} else {
			$out = $this->controller->site->replaceLoop($out, 'if newpages', array());
		}
		
		$out = $this->controller->site->replaceLoop($out, 'categories', $params['categories']);
		
		$out = $this->controller->site->replaceLoop($out, 'links', $params['links']);
		$linksOriginal = $this->controller->link->findAll();
		$out = $this->controller->site->replaceLoop($out, 'link_more', count($linksOriginal) > 5 ? array(array('link_more_link' => 'link/')) : array());
		$replace = array(
			'plugin_header' => $pluginHeader,
			'plugin1' => $pluginHtml[0],
			'plugin2' => $pluginHtml[1],
			'plugin3' => $pluginHtml[2],
			'plugin4' => $pluginHtml[3],
			'plugin5' => $pluginHtml[4],
			'plugin6' => $pluginHtml[5],
		);
		$out = $this->controller->site->replaceParams($out, $replace);
		
		$out = $this->replaceCommon($out);
		$out = $this->controller->site->replaceCommon($out);
		$out = mb_convert_encoding($out, 'SJIS', 'UTF-8');
		if ($params['preview']) return $out;
		$this->urls[] = $this->config['url'];
		return $this->controller->site->output(SITE_PATH . 'index.' . $this->config['ext'], $out);
	}
	
	
	function generateCopyright($params) {
		$this->generateStart($params);
		$out = file_get_contents(dirname(__FILE__) . '/web_templates/copyright.html');
		$out = $this->replaceLogo($out);
		$plugins = $this->controller->plugin->findAllWithClass(array('used' => 1));
		
		$pluginHeader = '';
		$pluginParams = array('controller' => $this->controller);
		foreach ($plugins as $plugin) {
			for ($i = 0; $i < 6; $i++) {
				if (method_exists($plugin['class'], 'generateCopyrightHeader')) {
					$pluginHeader .= $plugin['class']->generateCopyrightHeader($pluginParams);
				}
			}
		}
		$replace = array(
			'plugin_header' => $pluginHeader,
		);
		$out = $this->controller->site->replaceParams($out, $replace);
		
		$keys = array('title', 'company', 'contact_name', 'address', 'tel', 'email', 'itemname', 'price', 'pay', 'other', 'privacy');
		$names = array('サイト名', '会社名', '担当者名', '連絡先住所', '電話番号', 'メールアドレス', '商品名', '利用料金', '支払い方法', 'その他事項', 'プライバシーポリシー');
		$data = array();
		foreach ($keys as $i => $key) {
			if ($this->config[$key]) {
				$data[] = array(
					'data_title' => $names[$i],
					'data_value' => nl2br(h($this->config[$key])),
				);
			}
		}
		$out = $this->controller->site->replaceLoop($out, 'data', $data);
		$out = $this->controller->site->replaceCommon($out);
		$out = $this->replaceCommon($out);
		$out = mb_convert_encoding($out, 'SJIS', 'UTF-8');
		if ($params['preview']) return $out;
		$this->urls[] = $this->config['url'] . 'copyright.' . $this->config['ext'];
		return $this->controller->site->output(SITE_PATH . 'copyright.' . $this->config['ext'], $out);
	}
	
	
	function generateCategories($params) {
		$this->generateStart($params);
		$outOriginal = file_get_contents(dirname(__FILE__) . '/web_templates/category.html');
		$outOriginal = $this->replaceLogo($outOriginal);
		$plugins = $this->controller->plugin->findAllWithClass(array('used' => 1));
		$pages = $params['pages'];
		$category = $params['category'];
		$category2 = $params['category2'];
		$categories2 = $params['categories2'];
		$limit = 10;
		foreach ($plugins as $plugin) {
			if (method_exists($plugin['class'], 'generateNewPages')) {
				$pluginParams = array(
					'controller' => $this->controller,
					'category' => $params['category'],
					'category2' => $params['category2'],
					'pages' => $params['pages'],
				);
				$newPages = $plugin['class']->generateNewPages($pluginParams);
				$pages = array_merge($pages, $newPages);
			}
		}
		foreach ($pages as $i => $page) {
			if ($page['url']) {
				$page['page_link'] = h($page['url']);
			} else {
				$page['page_link'] = $this->config['url'] . $category2['id'] . '/' . $page['id'] . '.' . $this->config['ext'];
			}
			$page['page_name'] = h($page['name']);
			$pages[$i] = $page;
		}
		$originalPages = $pages;
		for ($pageNo = 0; $originalPages[$pageNo * $limit] || !$pageNo; $pageNo++) {
			$out = $outOriginal;
			$pages = array_slice($originalPages, $pageNo * $limit, $limit);
			if ($pages) {
				$out = $this->controller->site->replaceLoop($out, 'pages', $pages);
			} else {
				$out = $this->controller->site->replaceLoop($out, 'if pages', array());
			}
			
			// sub_categories
			$out = $this->controller->site->replaceLoop($out, 'sub_categories', $categories2);
			$pluginHeader = '';
			$pluginHtml = array('', '', '', '', '', '');
			foreach ($plugins as $plugin) {
				for ($i = 0; $i < 6; $i++) {
					if (method_exists($plugin['class'], 'generateCategory')) {
						$param = array(
							'controller' => $this->controller,
							'category' => $category,
							'category2' => $category2,
						);
						$pluginHtml[$i] .= $plugin['class']->generateCategory($i + 1, $param);
					}
					if (method_exists($plugin['class'], 'generateCategoryHeader')) {
						$pluginHeader .= $plugin['class']->generateCategoryHeader($pluginParams);
					}
				}
			}
			if ($pageNo) {
				if ($pageNo == 1) $link_prev_link = '.';
				else $link_prev_link = 'index' . $pageNo . '.' . $this->config['ext'];
				$data = array(array('link_prev_link' => $link_prev_link));
			} else {
				$data = array();
			}
			$out = $this->controller->site->replaceLoop($out, 'link_prev', $data);
			if ($originalPages[($pageNo + 1) * $limit]) {
				$data = array(array('link_next_link' => 'index' . ($pageNo + 2) . '.' . $this->config['ext']));
			} else {
				$data = array();
			}
			$out = $this->controller->site->replaceLoop($out, 'link_next', $data);
			
			$out = $this->replaceCommon($out, $category2['keyword']);
			$changes = array(
				'ad_header' => $this->controller->site->convertInput('config_ad3', $this->config['ad3']),
				'ad_footer' => $this->controller->site->convertInput('config_ad4', $this->config['ad4']),
			);
			$out = $this->controller->site->replaceCommon($out,  $changes);
			
			if ($category2['url']) {
				$body = '<a href="' . $category2['url'] . '">' . $category2['url'] . '</a>';
			} else {
				$body = $category2['body'];
			}
			
			$replace = array(
				'category_name' => h($category['name']),
				'category2_name' => h($category2['name']),
				'body' => nl2br($body),
				'plugin_header' => $pluginHeader,
				'plugin1' => $pluginHtml[0],
				'plugin2' => $pluginHtml[1],
				'plugin3' => $pluginHtml[2],
				'plugin4' => $pluginHtml[3],
				'plugin5' => $pluginHtml[4],
				'plugin6' => $pluginHtml[5],
			);
			$out = $this->controller->site->replaceParams($out, $replace);
			$out = mb_convert_encoding($out, 'SJIS', 'UTF-8');
			@mkdir(SITE_PATH . $category2['id']);
			chmod(SITE_PATH . $category2['id'], 0755);
			$filename = 'index';
			if ($pageNo) $filename .= ($pageNo + 1);
			$filename .= '.' . $this->config['ext'];
			$this->urls[] = $this->config['url'] . $category2['id'] . '/' . $filename;
			$this->controller->site->output(SITE_PATH . $category2['id'] . '/' . $filename, $out);
		}
		
		$this->controller->site->generatePages($category, $category2, $originalPages);
	}
	
	
	function generatePages($params) {
		$this->generateStart($params);
		$outOriginal = file_get_contents(dirname(__FILE__) . '/web_templates/page.html');
		$outOriginal = $this->replaceLogo($outOriginal);
		$plugins = $this->controller->plugin->findAllWithClass(array('used' => 1));
		$category = $params['category'];
		$category2 = $params['category2'];
		$pages = $params['pages'];
		foreach ($pages as $i => $page) {
			if ($page['url']) {
				$page['page_link'] = h($page['url']);
			} else {
				$page['page_link'] = $this->config['url'] . $category2['id'] . '/' . $page['id'] . '.' . $this->config['ext'];
			}
			$page['page_name'] = h($page['name']);
			$pages[$i] = $page;
		}
		$limit = 10;
		$innerPages = array_slice($pages, 0, $limit);
		
		foreach ($pages as $page) {
			$out = $outOriginal;
			
			$out = $this->controller->site->replaceLoop($out, 'pages', $innerPages);
			
			$out = $this->controller->site->replaceLoop($out, 'link_prev', array());
			if ($pages[$limit]) {
				$data = array(array('link_next_link' => 'index2.' . $this->config['ext']));
			} else {
				$data = array();
			}
			$out = $this->controller->site->replaceLoop($out, 'link_next', $data);

			$pluginHeader = '';
			$pluginHtml = array('', '', '', '', '', '');
			foreach ($plugins as $plugin) {
				for ($i = 0; $i < 6; $i++) {
					if (method_exists($plugin['class'], 'generatePage')) {
						$category2 = $this->controller->category2->read($page['category2_id']);
						$category = $this->controller->category->read($category2['category_id']);
						$params = array(
							'controller' => $this->controller,
							'category' => $category,
							'category2' => $category2,
							'page' => $page,
						);
						$pluginHtml[$i] .= $plugin['class']->generatePage($i + 1, $params);
					}
					if (method_exists($plugin['class'], 'generatePageHeader')) {
						$pluginHeader .= $plugin['class']->generatePageHeader($params);
					}
				}
			}
			
			$out = $this->replaceCommon($out, $page['keyword']);
			$changes = array(
				'ad_header' => $this->controller->site->convertInput('config_ad3', $this->config['ad3']),
				'ad_footer' => $this->controller->site->convertInput('config_ad4', $this->config['ad4']),
			);
			$out = $this->controller->site->replaceCommon($out, $changes);
			
			if ($page['url']) {
				$body = '<a href="' . $page['url'] . '">' . $page['url'] . '</a>';
			} else {
				$body = $page['body'];
			}
			
			$replace = array(
				'category_name' => h($category['name']),
				'category2_name' => h($category2['name']),
				'category2_id' => $category2['id'],
				'page_name' => h($page['name']),
				'body' => nl2br($body),
				'plugin_header' => $pluginHeader,
				'plugin1' => $pluginHtml[0],
				'plugin2' => $pluginHtml[1],
				'plugin3' => $pluginHtml[2],
				'plugin4' => $pluginHtml[3],
				'plugin5' => $pluginHtml[4],
				'plugin6' => $pluginHtml[5],
			);
			$out = $this->controller->site->replaceParams($out, $replace);
			$out = mb_convert_encoding($out, 'SJIS', 'UTF-8');
			@mkdir(SITE_PATH . $category2['id']);
			chmod(SITE_PATH . $category2['id'], 0755);
			$this->urls[] = $this->config['url'] . $category2['id'] . '/' . $page['id'] . '.' . $this->config['ext'];
			$this->controller->site->output(SITE_PATH . $category2['id'] . '/' . $page['id'] . '.' . $this->config['ext'], $out);
		}
	}
	
	
	function generateSearchPages($params) {
		$this->generateStart($params);
		$outOriginal = file_get_contents(dirname(__FILE__) . '/web_templates/page.html');
		$outOriginal = $this->replaceLogo($outOriginal);
		$plugins = $this->controller->plugin->findAllWithClass(array('used' => 1));
		$pages = $params['pages'];
		$id = $params['id'];
		$keyword = $params['keyword'];
		$limit = 10;

		for ($pageNo = 0; $pages[$pageNo * $limit]; $pageNo++) {
			$out = $outOriginal;
			
			if (($pos = strpos($out, '<!--if page-->')) !== false) {
				if (($endpos = strpos($out, '<!--/if-->', $pos)) !== false) {
					$out = substr_replace($out, '', $pos, $endpos - $pos + 1 + 10);
				}
			}
			
			$innerPages = array_slice($pages, $pageNo * $limit, $limit);
			$out = $this->controller->site->replaceLoop($out, 'pages', $innerPages);
			
			if ($pageNo) {
				$name = $pageNo == 1 ? ("$id." . $this->config['ext']) : ($id . '_' . $pageNo . '.' . $this->config['ext']);
				$data = array(array('link_prev_link' => $name));
			} else {
				$data = array();
			}
			$out = $this->controller->site->replaceLoop($out, 'link_prev', $data);
			
			if ($pages[($pageNo + 1) * $limit]) {
				$data = array(array('link_next_link' => $id . '_' . ($pageNo + 2) . '.' . $this->config['ext']));
			} else {
				$data = array();
			}
			$out = $this->controller->site->replaceLoop($out, 'link_next', $data);

			$pluginHtml = array('', '', '', '', '', '');
			$pluginHeader = '';
			foreach ($plugins as $plugin) {
				for ($i = 0; $i < 6; $i++) {
					if (method_exists($plugin['class'], 'generateSearchPage')) {
						$params = array(
							'controller' => $this->controller,
							'page' => $page,
							'id' => $params['id'],
							'keyword' => $params['keyword'],
							'pageNo' => $pageNo,
						);
						$pluginHtml[$i] .= $plugin['class']->generateSearchPage($i + 1, $params);
					}
				}
				if (method_exists($plugin['class'], 'generateSearchPageHeader')) {
					$pluginHeader .= $plugin['class']->generateSearchPageHeader($params);
				}
			}
			$out = $this->replaceCommon($out, $params['keyword']);
			$out = $this->controller->site->replaceCommon($out);
			
			$replace = array(
				'page_name' => h($keyword),
				'body' => '',
				'plugin_header' => $pluginHeader,
				'plugin1' => $pluginHtml[0],
				'plugin2' => $pluginHtml[1],
				'plugin3' => $pluginHtml[2],
				'plugin4' => $pluginHtml[3],
				'plugin5' => $pluginHtml[4],
				'plugin6' => $pluginHtml[5],
			);
			$out = $this->controller->site->replaceParams($out, $replace);
			$out = mb_convert_encoding($out, 'SJIS', 'UTF-8');
			$filename = $pageNo ? ($id . '_' . ($pageNo + 1) . '.' . $this->config['ext']) : ("$id." . $this->config['ext']);
			$this->urls[] = $this->config['url'] . 'search/' . $filename;
			$this->controller->site->output(SITE_PATH . 'search/' . $filename, $out);
		}
	}
	
	
	function generateLinks($params) {
		$this->generateStart($params);
		$outOriginal = file_get_contents(dirname(__FILE__) . '/web_templates/link.html');
		$outOriginal = $this->replaceLogo($outOriginal);
		$links = $this->controller->link->findAll();
		$links = array_slice($links, 5);
		foreach ($links as $i => $link) {
			$link['link_url'] = h($link['url']);
			$link['link_name'] = $link['image'] ? ('<img src="' . h($link['image']) . '" border="0" />') : h($link['name']);
			$links[$i] = $link;
		}
		$limit = 10;
		@mkdir(SITE_PATH . 'link');
		@chmod(SITE_PATH . 'link', 0755);
		for ($start = 0; $links[$start]; $start += $limit) {
			$out = $outOriginal;
			$currentLinks = array_slice($links, $start, $limit);
			$out = $this->controller->site->replaceLoop($out, 'links', $currentLinks);
			if ($start) {
				if ($start == $limit) $link_prev_link = '.';
				else $link_prev_link = ($start / $limit) . '.' . $this->config['ext'];
				$data = array(array('link_prev_link' => $link_prev_link));
			} else {
				$data = array();
			}
			$out = $this->controller->site->replaceLoop($out, 'link_prev', $data);
			if ($links[$start + $limit]) {
				$data = array(array('link_next_link' => (($start / $limit) + 2) . '.' . $this->config['ext']));
			} else {
				$data = array();
			}
			$out = $this->controller->site->replaceLoop($out, 'link_next', $data);
			
			$out = $this->replaceCommon($out);
			$out = $this->controller->site->replaceCommon($out, array('title' => 'リンク' . (($start / $limit) + 1)));
			
			$out = mb_convert_encoding($out, 'SJIS', 'UTF-8');
			$filename = $start ? (($start / $limit) + 1) : 'index';
			$filename .= '.' . $this->config['ext'];
			$this->urls[] = $this->config['url'] . 'link/' . $filename;
			$this->controller->site->output(SITE_PATH . 'link/' . $filename, $out);
		}
	}
	
	
	function generateMessage($params) {
		$this->generateStart($params);
		$out = file_get_contents(dirname(__FILE__) . '/web_templates/msg.html');
		$out = $this->replaceLogo($out);
		$out = $this->replaceCommon($out);
		$out = $this->controller->site->replaceCommon($out);
		$out = $this->controller->site->replaceParams($out, array('msg' => $params['msg'], 'plugin_header' => ''));
		$out = mb_convert_encoding($out, 'SJIS', 'UTF-8');
		return $out;
	}
	
	
	function generateRss($params) {
		$this->generateStart($params);
		$newpages = $this->controller->newpage->findAll(null, 'created DESC', 30);
		$out = '<?xml version="1.0" encoding="utf-8"?>
<rss version="2.0"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:sy="http://purl.org/rss/1.0/modules/syndication/"
	xmlns:admin="http://webns.net/mvcb/"
	xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">


    <channel>
		<title>' . h($this->config['title']) . '</title>
    <link>' . $this->config['url'] . '</link>
		<description>' . h($this->config['title']) . '</description>
    <dc:language>ja</dc:language>
	<dc:creator>admin</dc:creator>
		<dc:date>' . date('r') . '</dc:date>';
		foreach ($newpages as $newpage) {
			$title = h($newpage['name']);
			$url = $this->config['url'] . $newpage['url'];
			if ($url[strlen($url) - 1] == '/') {
				// category
				preg_match('/^([0-9]+)/', $newpage['url'], $match);
				$category2 = $this->controller->category2->read($match[1]);
				$category2['body'] = strip_tags($category2['body']);
				$description = mb_strlen($category2['body']) < 100 ? $category2['body'] : (mb_substr($category2['body'], 0, 100) . '...');
				$category = $this->controller->category->find(array('id' => $category2['category_id']));
				$subject = h($category['name']);
			} else if (substr($newpage['url'], 0, 6) == 'search') {
				// search
				$url .= '.' . $this->config['ext'];
				$description = '';
				$subject = '';
			} else {
				// page
				$url .= '.' . $this->config['ext'];
				preg_match('/^[0-9]+\/([0-9]+)/', $newpage['url'], $match);
				$page = $this->controller->page->read($match[1]);
				$page['body'] = strip_tags($page['body']);
				$description = mb_strlen($page['body']) < 100 ? $page['body'] : (mb_substr($page['body'], 0, 100) . '...');
				$category2 = $this->controller->category2->find(array('id' => $page['category2_id']));
				$subject = h($category2['name']);
			}
			$out .= '<item>
			<title>' . h($title) . '</title>
    <link>' . $url . '</link>
			<description>' . h($description) . '</description>
			<dc:subject>' . h($subject) . '</dc:subject>
    <dc:creator>admin</dc:creator>
			<dc:date>' . date('r', strtotime($newpage['created'])) . '</dc:date>
  </item>';
		}
		$out .= '</channel>
		</rss>';
		return $this->controller->site->output(SITE_PATH . 'rss.xml', $out);
	}
	
	
	function generateSitemap($params) {
		$this->generateStart($params);
		$date = date('Y-m-d');
		$out = '<?xml version="1.0" encoding="UTF-8"?>
<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9" xmlns:mobile="http://www.google.com/schemas/sitemap-mobile/1.0">';
		foreach ($this->urls as $i => $url) {
			$out .= '<url>
      <loc>' . $url . '</loc>
      <lastmod>' . $date . '</lastmod>
	  <mobile:mobile/>
      <changefreq>daily</changefreq>
	<priority>' . ($i + 1 == count($this->urls) ? 1.0 : 0.5) . '</priority>
   </url>';
		}
		$out .= '</urlset>';
		$this->controller->site->output(SITE_PATH . 'sitemap.xml', $out);
	}
	
	
	function replaceCommon($out, $keyword = null) {
		$menuItems = array();
		$plugins = $this->controller->plugin->findAllWithClass(array('used' => 1));
		foreach ($plugins as $plugin) {
			if (method_exists($plugin['class'], 'getMenuItems')) {
				$results = $plugin['class']->getMenuItems();
				$menuItems = array_merge($results, $menuItems);
			}
		}
		if ($menuItems) {
			$out = $this->controller->site->replaceLoop($out, 'plugin_menu_items', $menuItems);
		} else {
			$out = $this->controller->site->replaceLoop($out, 'if plugin_menu_items', array());
		}

		if ($this->config['keyword']) {
			if ($keyword) {
				$keyword = $this->config['keyword'] . ',' . $keyword;
			} else {
				$keyword = $this->config['keyword'];
			}
		}
		$keyword = $this->controller->site->convertInput('config_keyword', h($keyword));
		$replace = array(
			'show_title' => $this->style['hide_title'] ? '' : $this->controller->site->convertInput('config_title', h($this->config['title'])),
			'body_bgcolor' => h($this->style['bgcolor']),
			'body_text' => h($this->style['text']),
			'body_link' => h($this->style['link']),
			'body_vlink' => h($this->style['vlink']),
			'body_alink' => h($this->style['alink']),
			'fontsize' => h($this->style['fontsize']),
			'marquee_bgcolor' => h($this->style['marquee_color']),
			'marquee_color' => h($this->style['marquee']),
			'new_bgcolor' => h($this->style['new_bgcolor']),
			'new_color' => h($this->style['new_color']),
			'category_bgcolor' => h($this->style['category_bgcolor']),
			'category_color' => h($this->style['category_color']),
			'pages_bgcolor' => h($this->style['pages_bgcolor']),
			'pages_color' => h($this->style['pages_color']),
			'link_bgcolor' => h($this->style['link_bgcolor']),
			'link_color' => h($this->style['link_color']),
			'keyword' => $keyword,
		);
		$out = $this->controller->site->replaceParams($out, $replace);
		$out = preg_replace('/(<td[^>]*>)/i', '$1<font size="' . h($this->style['fontsize']) . '">', $out);
		$out = preg_replace('/<\/td>/i', '</font></td>', $out);
		return $out;
	}
	
	
	function replaceLogo($out) {
		if ($this->style['image']) {
			$image = '<img src="' . $this->config['url'] . 'images/' . $this->style['image'] . '" />';
			$out = preg_replace('/<!--logo-->.+<!--\/logo-->/', $image, $out);
		}
		return $out;
	}
	
	
	function getPageCount() {
		return count($this->urls);
	}
}	
